"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateLogger = exports.CreateOptions = exports.DebugInterceptor = void 0;
__exportStar(require("@nofrills/lincoln"), exports);
var debug_1 = __importDefault(require("debug"));
var lincoln_1 = require("@nofrills/lincoln");
var Cache = {};
exports.DebugInterceptor = function (log) {
    var logger = Cache[log.namespace]
        ? Cache[log.namespace]
        : (Cache[log.namespace] = debug_1.default(log.namespace));
    if (log.parameters.length && typeof log.parameters[0] === 'string') {
        logger(log.parameters[0], log.parameters.slice(1));
    }
    else {
        logger(log.parameters);
    }
    return log;
};
exports.CreateOptions = function (namespace, filters, interceptors) {
    var options = {
        emitNamespace: true,
        emitTag: true,
        filters: new lincoln_1.LincolnRegistry(filters),
        interceptors: new lincoln_1.LincolnRegistry(interceptors),
        namespace: namespace,
        separator: ':',
    };
    options.interceptors.register('debug-interceptor', exports.DebugInterceptor);
    return options;
};
exports.CreateLogger = function (options) {
    if (typeof options === 'string') {
        return new lincoln_1.Lincoln(exports.CreateOptions(options));
    }
    return new lincoln_1.Lincoln(options);
};
//# sourceMappingURL=index.js.map